#!/bin/bash

ds=$1
pos=$2
log_path="./${ds}-slot$pos/best_params"
data_path="./${ds}-slot$pos/data"
b_ratio=1e-2
net_u='Linear'
net_v='Linear'
optim='NewtonCG'
CGmax=30

# params
params=`tail -n2 ./${ds}-slot$pos/params | head -n1`
#echo "$params"
loss="7"
t=`echo ${params} | cut -d'_' -f2`
lr=`echo ${params} | cut -d'_' -f3`
l=`echo ${params} | cut -d'_' -f4`
k=`echo ${params} | cut -d'_' -f5`
tn=`echo ${params} | cut -d'_' -f6`
zeta=`echo ${params} | cut -d'_' -f7`
bl=`echo ${params} | cut -d'_' -f7`
sn=`echo ${params} | cut -d'_' -f7`
w=`echo ${params} | cut -d'_' -f8`
r=`echo ${params} | cut -d'_' -f9`
t=$(echo "${t}" | bc -l)


task(){
# Set up train command
train_cmd="CUDA_VISIBLE_DEVICES=-1 python ./train.py"
train_cmd="${train_cmd} --u_set $data_path/tr.svm"
train_cmd="${train_cmd} --v_set $data_path/label.svm"
train_cmd="${train_cmd} --val_set $data_path/te.svm"
train_cmd="${train_cmd} --va_tpk $data_path/te.tpk"
#train_cmd="${train_cmd} --skip_mask te.skm"
train_cmd="${train_cmd} --opt ${optim}"
#train_cmd="${train_cmd} --b_ratio ${b_ratio}"
train_cmd="${train_cmd} --net_u ${net_u}"
train_cmd="${train_cmd} --net_v ${net_v}"
train_cmd="${train_cmd} --CGmax ${CGmax}"

# Print out all parameter pair
cmd="${train_cmd} --loss ${loss} -t ${t} --lr ${lr} --lambda ${l} -k ${k} -tpk_num ${tn}"
if [ "$loss" == "7" ]; then
    cmd="${cmd} -zeta ${zeta}"
    cmd="${cmd} --omega ${w}"
    cmd="${cmd} -r ${r}"
    cmd="${cmd} --R $data_path/tr.Rn --weights $data_path/tr.nzinfo"
    cmd="${cmd} --log ${log_path}/${loss}_${lr}_${l}_${k}_${tn}_${zeta}_${w}_${r}_${t}.log"
fi
echo "${cmd}"
}


# Check command
task
wait


# Run
task | xargs -0 -d '\n' -P 2 -I {} sh -c {}
