import os, sys
import numpy as np
from scipy.sparse import csr_matrix
import torch
from torch.nn import functional as F
from util import read_data, csr2tensor
from sklearn.metrics import roc_auc_score
from collections import Counter

_, Yte = read_data(sys.argv[1], True)
Y2 = csr2tensor(Yte.Label)
#print(np.unique(Y2._values()))
#P2, Q2 = np.load(sys.argv[2]), np.load(sys.argv[3])
#P2, Q2 = torch.tensor(P2), torch.tensor(Q2)
#p_a_te = torch.mm(P2, Q2.T)
p_a_te = torch.Tensor(1.0/Yte.IPS.toarray())

print('='*10)
if sys.argv[4] == 'policy':
    p_a_te = F.softmax(p_a_te, dim = 1)
    print('(P) Average Var: %.6f'%torch.mean(torch.var(p_a_te, dim=1)))
    #print('(P) Average Mean: %.6f'%torch.mean(torch.mean(p_a_te, dim=1)))
else:
    #p_a_te = torch.sigmoid(p_a_te)
    print('(V) Average Var: %.6f'%torch.mean(torch.var(p_a_te, dim=1)))
    print('(V) Average Mean: %.6f'%torch.mean(torch.mean(p_a_te, dim=1)))

if sys.argv[4] != 'policy':
    p_te = p_a_te[Y2._indices()[0, :], Y2._indices()[1, :]]
    print('Auc:%.4f'%roc_auc_score(Y2._values().numpy(), p_te.numpy()))#, labels=[-1, 1]))
    p_a_te = p_a_te/p_a_te.sum(dim=1, keepdim=True)
    #p_a_te = F.softmax(p_a_te, dim = 1)

p_e_te = p_a_te[Y2._indices()[0, :][Y2._values() == 1], Y2._indices()[1, :][Y2._values() == 1]]
print('Expected Va-reward:%.4f'%torch.sum(p_e_te))

max_id = torch.argmax(p_a_te, dim=1).numpy()
#max_id = np.random.choice(np.arange(100), replace=True, size=(Y2.shape[0],))
Y_hat = csr_matrix((np.ones(max_id.shape[0]), (np.arange(max_id.shape[0], dtype=np.int), max_id.astype(np.int))), shape=Y2.shape)
reward = csr2tensor(Y_hat).mul(Y2)
print('Greedy Va-reward:%.4f'%torch.sum(reward._values() > 0))
#print(Counter(max_id))
#print(Counter(reward._indices()[1,:][reward._values() > 0].numpy()))


