#!/bin/bash

# params
k=128
t=50
CGmax=30
lr=0.01
#loss=1
#b_ratio=1
net_u='Linear'
net_v='Linear'
#optim='General'

# others
log_path="./grid_logs"

task(){
# Set up train command
train_cmd="CUDA_VISIBLE_DEVICES=-1 python ./train.py"
train_cmd="${train_cmd} --u_set ./tr.svm"
train_cmd="${train_cmd} --v_set ./label.svm"
train_cmd="${train_cmd} --val_set ./va.svm"
#train_cmd="${train_cmd} --skip_mask va.skm"
#train_cmd="${train_cmd} --R tr.Rn --weights tr.nzinfo"
train_cmd="${train_cmd} -t ${t} -k ${k}"
#train_cmd="${train_cmd} --opt ${optim}"
#train_cmd="${train_cmd} --b_ratio ${b_ratio} --lr ${lr} --loss ${loss}"
train_cmd="${train_cmd} --CGmax ${CGmax}"
train_cmd="${train_cmd} --net_u ${net_u}"
train_cmd="${train_cmd} --net_v ${net_v}"

# Print out all parameter pair
for l in 0.015625 0.0625 0.25 1 4 #0.00390625
do
    for w in 0.00390625 0.015625 0.0625 0.25
    #for w in 1e-2 #0.0009765625 0.015625 0.25
    do
        for r in -1 -4
        do
            cmd="${train_cmd} --lambda ${l}"
            cmd="${cmd} --omega ${w}"
            cmd="${cmd} -r ${r}"
            cmd="${cmd} --log ${log_path}/${l}_${w}_${r}_${k}.log"
            echo "${cmd}"
        done
    done
done
}

# Check command
task
wait

# Run
task | xargs -0 -d '\n' -P 2 -I {} sh -c {}
