
import numpy as np
import scipy as sp
from scipy.sparse import csr_matrix
import os, sys
from utils import *
from sklearn.datasets import load_svmlight_file
from collections import deque


data_root = sys.argv[1]
P = np.load(sys.argv[2])
Q = np.load(sys.argv[3])
temp = float(sys.argv[4])
start = int(sys.argv[5])
end = int(sys.argv[6])
seed = int(sys.argv[7])
pos = int(sys.argv[8])
policy = sys.argv[9]
noise_scale = float(sys.argv[10])
eps = float(sys.argv[11])
tK = int(sys.argv[12])
alpha = float(sys.argv[13])
P = P[start:end, :]
bsize=1024

np.random.seed(seed)
in_list = [data_root, './label.svm']
out_file = data_root[:-4]+'.%s.svm.part%d'%(policy, seed)
pos_file = data_root[:-4]+'.%s.plm.part%d'%(policy, seed)
top_file = data_root[:-4]+'.%s.tpk.part%d'%(policy, seed) 

X, y = load_svmlight_file(open(in_list[0], 'rb'), multilabel=True)
assert X.shape[0] == end - start 
m = P.shape[0]
n = Q.shape[0]

eva = Evaluator(P, Q, X, y, eps, bsize, temp, pos, noise_scale, tK, alpha)

with open(out_file, 'w') as fout, \
        open(pos_file, 'w') as fpout, \
        open(top_file, 'w') as ftout:
    X_out, idx_out, propensity_out, value_out = [], [], [], []
    for p in range(pos):
        X_out.append(X)
    actions, pps, topK = eva.take_action(policy)
    rewards = eva.get_emp_reward(actions)

    # plmask and topK file
    for i in range(m):
        for p in range(1, pos+1):
            pline = ','.join('%d'%_i for _i in actions[i, :p])
            fpout.write('%s\n'%pline)
            tline = ','.join('%d'%_i for _i in topK[i, :])
            ftout.write('%s\n'%tline)

    idx_out.append(actions.reshape(-1,1))
    propensity_out.append(pps.reshape(-1,1))
    value_out.append(rewards.reshape(-1,1))

    X_out = csr_matrix(sp.sparse.hstack(X_out).reshape(-1, X.shape[1]))
    i_out = np.vstack(idx_out)
    p_out = np.vstack(propensity_out)
    v_out = np.vstack(value_out)
    dump_svm(fout, X_out, i_out, p_out, v_out)
